---
title: Xamarin.Android error/warning APT0000
description: APT0000 error/warning code
ms.date: 05/04/2018
---
# Xamarin.Android error/warning APT0000

## Example messages

```
error APT0000: res\drawable\image (1).png: Invalid file name: must contain only [a-z0-9_.]
```

```
error APT0000: Resource entry resource_name is already defined.
```

```
error APT0000: No resource found that matches the given name (at 'resource_name' with value '@string/foo').
```

```
error APT0000: invalid resource directory name: obj\Debug\dir with spaces "dir with spaces".
```

```
warning APT0000: warning: string 'resource_name' has no default translation.
```

## Issue

This message indicates that `aapt` (Android Asset Packaging Tool) reported an error or warning. `aapt` is part of the Android SDK and is used internally by Xamarin.Android to process and compile resources into binary assets.

Errors reported by `aapt` are outside of Xamarin.Android's control, so a general error code of APT0000 is used reporting the exact message coming from `aapt`.

## Solution

To learn more about `aapt` and Android resources, see the [Android documentation](https://developer.android.com/guide/topics/resources/accessing-resources.html).
