---
title: Xamarin.Android warning XA4305
description: XA4305 warning code
ms.date: 02/11/2020
---
# Xamarin.Android warning XA4305

## Example messages

```
Multidex is enabled, but `$(_AndroidMainDexListFile)` is empty.
```

```
Multidex is enabled, but the `$(_AndroidMainDexListFile)` file 'obj\Release\90\multidex.keep' does not exist.
```

## Solution

The build process should automatically configure and populate the file for the
`$(_AndroidMainDexListFile)` property, so please consider submitting a
[bug][bug] if you are getting this warning under normal circumstances.

[bug]: https://github.com/xamarin/xamarin-android/wiki/Submitting-Bugs,-Feature-Requests,-and-Pull-Requests
